// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#ifndef	__HCONSTS__
#define	__HCONSTS__

#define 	DateAndTime_Get 	_rom_call(void,(unsigned short*, unsigned short*, unsigned short*, unsigned short*, unsigned short*, unsigned short*),5F3)
#define 	WinRemove 			_rom_call(void,(WINDOW*,short),414)
#define 	IsClockOn 			_rom_call(BOOL,(void),5F7)

#define		DF_VERSION				0xFF05					// Version E of agnddata

#define		INFO_WINRECT			40,20,200,108
#define		INFO_LINE				24,46,132,46
#define		INFO_WIDTH				160

#define		MSG_BOX_MIN_WIDTH		170
#define		MSG_BOX_MAX_WIDTH		236
#define		MSG_BOX_MAX_ROWS		8

#define		KEY_2ND					4096
#define		N_TERM_BYTES			7						// num of Bytes for file end "\0data\0\TAG" = 7
#define		ENCODE_KEY_D			0xF2C4D1E5
#define		ENCODE_KEY_P			0xFEB593C7

#define		RET_MM_CONFIG			1
#define		RET_MM_PASSWORD			2
#define		RET_MM_MAKE_BACKUP		3
#define		RET_MM_RESTORE_BACKUP	4
#define		RET_MM_INFO				5

#define		RET_MA_GOTO				1
#define		RET_MA_DEL				2
#define		RET_MG_DAY				3
#define		RET_MG_ENTRY			12
#define		RET_MG_WEEK				4
#define		RET_MG_MONTH			5
#define		RET_MG_YEAR				6
#define		RET_MG_TODAY			7
#define		RET_MD_DAY				8
#define		RET_MD_OLD				13
#define		RET_MD_AREA				9
#define		RET_MD_WHOLE			10
#define		RET_MA_EDITDAY			11
#define		RET_MA_MOVE				14
#define		RET_MA_SHORTCUT			18
#define		RET_MV_NORMAL_VIEW		15
#define		RET_MV_MONTH_VIEW		16
#define		RET_MV_VIEW				17

#define		RET_LV_GM_GROUP			1
#define		RET_LV_GM_ADD			2
#define		RET_LV_GM_RENAME		3
#define		RET_LV_GM_DEL			4
#define		RET_LV_GM_SHORTCUT		14
#define		RET_LV_DS_ADD			6
#define		RET_LV_DS_EDIT			7
#define		RET_LV_DS_SHORTCUT		15
#define		RET_LV_DS_DEL			8
#define		RET_LV_DS_MOVE			9
#define		RET_LV_DS_MOVE_FOLDER	10
#define		RET_LV_DS_MOVE_UP		11
#define		RET_LV_DS_MOVE_DOWN		12
#define		RET_LV_DS_SORT			13

#define		DATE_MASK				(char *)"%02u.%02u.%04u"


#define		FLAG_ENCODED			0b0000000000000001
#define		FLAG_PASSWORD			0b0000000000000010
#define		FLAGS_AB				0b0000000000111000
#define		FLAG_CFGMASK			0b0000000000111110
#define		FLAGS_INIT				0b0000000000001000
#define		FLAG_AB_OFFSET			3
#define		FLAG_DATEFORMAT			0b0000000011000000
#define		FLAG_DELIMITER			0b0000001100000000
#define		FLAG_DF_OFFSET			6
#define		FLAG_DL_OFFSET			8

//#define		HF_NORMAL				1
//#define		HF_YEAR					2
//#define		HF_MONTH				3
//#define		HF_2WEEK				4
//#define		HF_WEEK					5

#define		ER_SUCCESS				0x00
#define		ER_COMMON				0xFF
#define		ER_DATAFILE_ARCHIVED	0x01
#define		ER_MAKE_TWIN			0x03
#define		ER_DEL_TWIN				0x04
#define		ER_MALLOC				0x05
#define		ER_CREATE_DATAFILE		0x06
#define		ER_WRONG_PW				0x09
#define		ER_COPY_SYM				0x11
#define		ER_SAVE_CONFIG			0x12
#define		ER_ARCHIVE_BF			0x14
#define		ER_UNARCHIVE_SYM		0x15
#define		ER_NO_BACKUPFILE		0x16
#define		ER_SYM_NOT_FOUND		0x17
#define		ER_WRONG_DF_VERSION		0x18
#define		ER_DELETE_SYM			0x19
#define		ER_GROUP_NOT_FOUND		0x21
#define		ER_GROUP_EXISTS			0x22
#define		ER_NAME_NOT_FOUND		0x23
#define		ER_NOENTRY				0x24		// MenuGotoNextEntry: if no Entry found
#define		ER_NO_CLOCK				0x25		// getToday: if clock is disabled or HW1 or AMS < 2.07
#define		ER_CHANGE_VIEW			0x26		// used as Return code to change between monthview and normal view in Agenda
#define		ER_ENTRY_NOT_FOUND		0x27		// findEntry() if header not found

#define		DAY_EXISTS				0x0100
#define		DAY_NEW					0x0200
#define		CANCEL					0x0300
#define		OK						0x0400
#define		SAVE_DAY				0x0500
#define		DONT_SAVE_DAY			0x0600

#define		MIN_DAY					7306
#define		MAX_DAY					43830

#define		TASK_AGENDA				0b00000001
#define		TASK_ADDRESSBOOK		0b00000010
#define		TASK_NOTEPAD			0b00000011
#define		TASK_INET_LINKS			0b00000100

#define		TASK_TASKMENU			0b00010001
#define		TASK_CHANGE				0b00001000
#define		TASK_NO_MESSAGE			0xFFFF

#define		MASK_VIEW				0b00000011		// two bits are reserved for mods
#define		NORMAL_VIEW				0b00000000		// but only two are used yet:
#define		SECOND_VIEW				0b00000001		// left, right or month, week
#define		EDITOR_VIEW				0b10000000		// editor is ored to save old mode

#define		KEY_INIT_DELAY			80
#define		BETWEEN_KEY_DELAY		15

#define 	DIAMOND_KEY				8192	
#define 	SHIFT_KEY				16384
#define 	HAND_KEY				1
#define 	LEFT_KEY				337
#define 	RIGHT_KEY				340
#define 	DOWN_KEY				344
#define 	UP_KEY					338
#define 	COS_KEY					260
#define 	SIN_KEY					259
#define 	TAN_KEY					261
#define 	LN_KEY					262
#define 	THETA_KEY				136
#define		SND_KEY					4096

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------

#endif
