// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AgndConv V.E oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Date:         November 2003 ooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------


#include "BuildOptions.h"
#include <TIGCClib.h>

#include "agndconv.h"
#include "consts.h"
#include "V3.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int Update2to3 (HANDLE handle)
{
	int				Ret				= ER_SUCCESS;
	TDAT			*DAT;
	char			*pOldData;
	int				OldSize			= 0;
	HANDLE			OldData			= H_NULL;
	TAgendaHeaderV3	*Header;
	char			*newPos;
	long			dSize;
	TFile			File;
  	WINDOW 			*Win 			= NULL;
	char			OldSizeBuf[50];
	char			EntriesBuf[50];
	char			SizeBuf[50];
	int				NumEntries		= 0;
	int				closeWin		= 0;

	if ( (MsgBox ((char *)"Conversion", (char *)"Update agnddata version 2\0to version 3?\0", BT_YES, BT_NO) == OK) &&
	     (MsgBox ((char *)"Warning", (char *)"Warning!\0 \0If you don't have enough free\0memory, the conversion will fail.\0Make a archived backup first!\0 \0Continue?\0", BT_YES, BT_NO) == OK) )
	{
		if ( (Win = HeapAllocPtr (sizeof (WINDOW))) == H_NULL) Ret = ER_MALLOC;
		else if (WinOpen (Win, MakeWinRect (40, 25, 200, 103), WF_SAVE_SCR | WF_TTY | WF_TITLE | WF_ROUNDEDBORDER, "Conversion") == 0) Ret = ER_MALLOC;
		if (Ret == ER_SUCCESS)
		{
			closeWin = 1;
			WinActivate (Win);
			WinFont (Win, F_6x8);
			WinAttr (Win, A_REPLACE);
			OldSize = peek_w (HeapDeref (handle))+2;
			sprintf (OldSizeBuf, "oldsize ........ %5d", OldSize);
			WinStrXY (Win, 10, 5, OldSizeBuf); 
			sprintf (EntriesBuf, "entries found .. %5d", NumEntries);
			WinStrXY (Win, 10, 15, EntriesBuf); 
			if ( (OldData = HeapAllocHigh (OldSize)) == H_NULL) Ret = ER_MALLOC;
		}
		
		if (Ret == ER_SUCCESS)
		{
			memmove (HeapDeref (OldData), HeapDeref (handle), OldSize);

			if (HeapRealloc (handle, sizeof(TDataFileV3)-1 ) == H_NULL) Ret = ER_MALLOC;

			if (Ret == ER_SUCCESS)
			{
				pOldData = HeapDeref (OldData);

				HeapLock (handle);
				File.handle = handle; 
				ReDerefDataFile (&File);
				InitEmptyDataFile (File.Header);
				File.Header->LastDay = peek_w (pOldData + 6);			// DAY_PTR was 
				
				if (peek_w (pOldData + 4) & FLAG_ENCODED) EncodeData (pOldData + 20, ENCODE_KEY_D, OldSize -N_TERM_BYTES - 20 );
				DAT = (TDAT *)( pOldData +20 );
				Header = (TAgendaHeaderV3 *)(File.DataPtr + File.Header->AgendaPtr);
				
				while ( (Ret == ER_SUCCESS) && (DAT->Day != 0) )
				{
					if ( (DAT->Day <= MAX_DAY) && (DAT->Day >= MIN_DAY) )
					{
						NumEntries++;
						sprintf (EntriesBuf, "entries found .. %5d", NumEntries);
						WinStrXY (Win, 10, 15, EntriesBuf); 
						dSize = RoundUpEven ((sizeof (TAgendaHeaderV3) - 2) + (strlen (DAT->AddrOffset + pOldData) +1));
						sprintf (SizeBuf, "new size ....... %5ld", File.Header->Size + dSize +2); 
						WinStrXY (Win, 10, 25, SizeBuf); 
						Ret = ReallocDataFile (&File, (char *)Header, File.Header->Size + dSize +2, &newPos);
						Header = (TAgendaHeaderV3 *)newPos;
						if (Ret == ER_SUCCESS)
						{
							memset (Header, 0, sizeof(TAgendaHeaderV3)-2);
							Header->Flag = 1;	// HF_NORMAL
							Header->Day = DAT->Day;
							Header->Size = (int)dSize;
							strcpy (&Header->Data, (DAT->AddrOffset + pOldData));
							AdjustAgendaSize (&File, dSize);
									
						}
						Header = (TAgendaHeaderV3*)( ((char *)Header) + Header->Size);
					}
					DAT += 1;
				}

			}

			HeapUnlock (handle);
			HeapUnlock (OldData);
			HeapFree (OldData);
			
		}
		DrawStaticButton (Win, BT_OK, 10);
		if (Ret == ER_SUCCESS) WinStrXY (Win, 10, 40, "Successfully converted!");
		else WinStrXY (Win, 10, 40, "Conversion failed!");
		ngetchx();

		if (closeWin) WinClose (Win);
		ST_busy (ACTIVITY_IDLE);

		if (Ret == ER_SUCCESS) MsgBox ((char *)"Conversion", (char *)"Note, that the options have been\0reseted to their default values.\0", BT_OK, BT_NONE);

	}
	else Ret = CANCEL;

	if (Win) HeapFreePtr (Win);

	return Ret;	
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void InitEmptyDataFile (TDataFileV3 *DataFile)
{
	char		*DFPtr = (char *)DataFile;
	
	memset (DFPtr, 0, sizeof(TDataFileV3)-1);
	DataFile->Size = sizeof(TDataFileV3)-3;
	DataFile->Version = 0xFF03;

	DataFile->AgendaPtr = (int)((char *)&DataFile->AgendaData -DFPtr);
	DataFile->AddressbookPtr = (int)((char *)&DataFile->AddressbookData -DFPtr);
	DataFile->NotesPtr = (int)((char *)&DataFile->NotesData -DFPtr);
	DataFile->INetLinksPtr = (int)((char *)&DataFile->INetLinksData -DFPtr);

	DataFile->AgendaSize = 2;
	DataFile->AddressbookSize = 2;
	DataFile->NotesSize = 2;
	DataFile->INetLinksSize = 2;

	sprintf (DataFile->Type, "data");
	DataFile->Tag = OTH_TAG;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int AdjustAgendaSize (TFile *File, long int SizeDelta)
{
	File->Header->AgendaSize += SizeDelta;
	File->Header->AddressbookPtr += SizeDelta;
	File->Header->NotesPtr += SizeDelta;
	File->Header->INetLinksPtr += SizeDelta;
	
	return 0;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
